<?php
//=======================================================================
// * snmp_execscripts.php
// * v1.0-1 (2015.02.15)
// * by red_neon (red_neon [at] dcpp [d0t] ru)
//=======================================================================

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

/* display No errors */
error_reporting(0);

if (isset($config)) {
	include_once(dirname(__FILE__) . "/../lib/snmp.php");
}

if (!isset($called_by_script_server)) {
	include_once(dirname(__FILE__) . "/../include/global.php");
	include_once(dirname(__FILE__) . "/../lib/snmp.php");

	array_shift($_SERVER["argv"]);

	print call_user_func_array("execscripts", $_SERVER["argv"]);
}

// <method>:<hostname>:<snmp_port>:<snmp_version>:<snmp_timeout>:<snmp_community>:<snmp_username>:<snmp_password>:<snmp_auth_protocol>:<snmp_priv_passphrase>:<snmp_priv_protocol>
function execscripts($snmp) {
	$snmp 		= explode(":", $snmp);
	$method 		= $snmp[0];
	$hostname 	= $snmp[1];
	$snmp_port 	= $snmp[2];
	$snmp_version = $snmp[3];
	$snmp_timeout = $snmp[4];
	
	$snmp_auth_username   	= "";
	$snmp_auth_password   	= "";
	$snmp_auth_protocol  	= "";
	$snmp_priv_passphrase 	= "";
	$snmp_priv_protocol   	= "";
	$snmp_context         	= "";
	$snmp_community 	= "";
	
	$ping_retries 	= 5;
	$max_oids 	= 50;

	if ($snmp_version == 3) {
		$snmp_auth_username 	= $snmp[6];
		$snmp_auth_password 	= $snmp[7];
		$snmp_auth_protocol 	= $snmp[8];
		$snmp_priv_passphrase 	= $snmp[9];
		$snmp_priv_protocol 	= $snmp[10];
	} else {
		$snmp_community = $snmp[5];
	}

	// .1.3.6.1.4.1.8072.1.3									all extend OIDs
	// .1.3.6.1.4.1.8072.1.3.2.2.1.2.strlen.str_ansii_code		cmd app
	// .1.3.6.1.4.1.8072.1.3.2.2.1.3.strlen.str_ansii_code		cmd args
	// .1.3.6.1.4.1.8072.1.3.2.3.1.2.strlen.str_ansii_code		full output
	
	// test:
	// snmpwalk -v 2c -c public 127.0.0.1 NET-SNMP-EXTEND-MIB::nsExtendOutputFull.\"test\" -O n
	
	// for test via snmpwalk need mib NET-SNMP-EXTEND-MIB
	// download it with: cd /usr/share/mibs/netsnmp/ && wget http://www.mibsearch.com/vendors/RFC/download/NET-SNMP-EXTEND-MIB

	$retval = 'U';
	$arr_method = str_split($method);
	$ansii_method = '';
	for ($i=0;($i<sizeof($arr_method));$i++) {
		$ansii_method = $ansii_method.".".ord($arr_method[$i]);
	}
	$oid = '.1.3.6.1.4.1.8072.1.3.2.3.1.2.'.strlen($method).$ansii_method;
	// $oid = "NET-SNMP-EXTEND-MIB::nsExtendOutputFull.\"$method\"";
	if ($ansii_method != '') {
		$rep = 0;
		while (true) {
			$snmp_data = cacti_snmp_get($hostname, $snmp_community, $oid, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, SNMP_POLLER);
			if ($snmp_data) {
				$retval = $snmp_data;
				break;
			} else {
				sleep(1);
			}
			if ( ($retval != 'U') || ($retval == 'U' && (++$rep > 5)) ) break;
		}
	}
	return $retval;
}

?>
